
#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include "wbtrv.h"
#include "blogin.h"

#define MKEYSIZE        20

typedef struct {
   int          op;
   char         key[MKEYSIZE];
}                       MonType;

/* Global Vars */
HANDLE                  hInst;
int                     OpenCount = 0;
static int              Fheight;
static int              MSize = 1;
static int              MStart = 0;
static int              MCount = 0;
static MonType          MonData[50];

#define WM_CALCULATE	(WM_USER + 0x123)

typedef struct {
	signed short   op;
	unsigned char  POS_BLK[128];
	unsigned char  key[256];
	signed short   keyNo;
	unsigned short len;
	unsigned char  data[2048];
}                            BTRVParms;

BOOL FAR PASCAL AboutProc (HWND hDlg, WORD message, WORD wParam, LONG lParam);

/*----------------------------------------------------------*
   Function: ShowOp
*-----------------------------------------------------------*/

static void ShowOp (HWND hWnd, BTRVParms far *BP)
/*---------------------------------------------*/
{
   int          idx;
   if (MCount < MSize) MCount++;
   else if (++MStart == MSize) MStart = 0;
   idx = MStart + MCount - 1;
   if (idx >= MSize) idx -= MSize;
   MonData[idx].op = BP->op;
   _fmemcpy (MonData[idx].key, BP->key, MKEYSIZE-1);
   InvalidateRect (hWnd, NULL, TRUE);
   UpdateWindow (hWnd);
} /* ShowOp */

/*-------------------------------------------------------------------------*/

BOOL CopyToClipboard (HWND hWnd, HGLOBAL hData)
{
	UINT MY_FMT;
	if (OpenClipboard (hWnd)) {
		EmptyClipboard();
		MY_FMT = RegisterClipboardFormat ("BtrvServer");
		SetClipboardData (MY_FMT, hData);
		CloseClipboard();
	}
	return TRUE;
} /* CopyToClipboard */

/*-------------------------------------------------------------------------*/

BOOL GetFromClipboard (HWND hWnd, LPSTR bp)
{
	LPCSTR ptr = NULL;
	if (OpenClipboard (hWnd)) {
		UINT MY_FMT = RegisterClipboardFormat ("BtrvServer");
		HANDLE hData = GetClipboardData (MY_FMT);
		if (ptr = (LPCSTR)GlobalLock (hData)) {
			_fmemcpy (bp, ptr, sizeof(BTRVParms));
			GlobalUnlock (hData);
		}
		CloseClipboard();               
	}
	return ptr != NULL;
}

/*----------------------------------------------------------*
 * Procedure: LogWndProc                                    *
 *----------------------------------------------------------*/

LONG FAR PASCAL LogWndProc (HWND hWnd, unsigned message, WORD wParam, LONG lParam)
/*------------------------------------------------------------------------------*/
{
   BTRVParms    far *BP;
   HANDLE       hParms;
   RECT         rc;
   HDC          hdc;
   int          status, i, Y, idx, op;
   char         buff[100];
   PAINTSTRUCT  ps;
   switch (message) {
   case WM_COMMAND:
      switch (wParam) {
      case I_ABOUT:
//         DialogBox (hInst, "AboutBox", hWnd, AboutProc);
         break;
      } /* wParam */
      return (TRUE);
   case WM_SIZE:
      hdc = GetDC (hWnd);
      Fheight = HIWORD(GetTextExtent (hdc, "X", 1));
      ReleaseDC (hWnd, hdc);
      i = HIWORD(lParam) / Fheight;
      if (i < 1) MSize = 1;
      else if (i > 50) i = 50;
      if (i != MSize) {
         MSize = i;
         MCount = MStart = 0;
      }
      break;
   case WM_PAINT:
      hdc = BeginPaint (hWnd, &ps);
      if (IsIconic (hWnd)) {
         GetClientRect (hWnd, &rc);
         Rectangle (hdc, 0, 0, rc.right, rc.bottom-1);
      } else {
         idx = MStart;
         i = MCount;
         Y = 0;
         while (i--) {
            wsprintf (buff, "%d\t%s", MonData[idx].op, (LPSTR)MonData[idx].key);
            TabbedTextOut (hdc, 0, Y, buff, strlen(buff), 0, NULL, 0);
            Y += Fheight;
            if (++idx == MSize) idx = 0;
         }
      }
      EndPaint (hWnd, &ps);
      return (0L);
   case WM_CALCULATE:
      hParms = GlobalAlloc (GMEM_MOVEABLE | GMEM_SHARE, sizeof(BTRVParms));
      BP = (BTRVParms far *)GlobalLock (hParms);
      if (BP == NULL) return -8888;
      if (!GetFromClipboard (hWnd, (LPSTR)BP)) {
         GlobalUnlock (hParms);
         GlobalFree (hParms);
         return -8888;
      }      	
      op = BP->op;
      if (IsIconic (hWnd)) {
         hdc = GetDC (hWnd);
         itoa (op, buff, 10);
         SelectObject (hdc, GetStockObject (NULL_PEN));
         Rectangle (hdc, 8, 1, 30, 16);
         TextOut (hdc, 8, 1, buff, strlen(buff));
         Rectangle (hdc, 8, 17, 30, 33);
         ReleaseDC (hWnd, hdc);
      } else
         ShowOp (hWnd, BP);
      status = BTRCALL (BP->op, BP->POS_BLK, BP->data, &(BP->len),
                        BP->key, 255, (unsigned char)BP->keyNo);
      GlobalUnlock (hParms);
      if (status == 0) {
         if (op == 0) OpenCount++;
         else if (op == 1) OpenCount--;
         else if (op == 28) OpenCount = 0;
         CopyToClipboard (hWnd, hParms);
      } else
         GlobalFree (hParms);
      if (IsIconic (hWnd)) {
         hdc = GetDC (hWnd);
         SetBkColor (hdc, 0x0000ff);
         itoa (status, buff, 10);
         TextOut (hdc, 8, 17, buff, strlen(buff));
         ReleaseDC (hWnd, hdc);
      }
      return (status);

   case WM_CLOSE:
      if (OpenCount) {
         char buff[300], buff2[300];
         LoadString (hInst, 1002, buff, sizeof(buff));
         wsprintf (buff2, buff, OpenCount);
         LoadString (hInst, 201, buff, sizeof(buff));
         if (MessageBox (hWnd, buff2, buff, MB_OKCANCEL | MB_DEFBUTTON2 | MB_ICONEXCLAMATION) != IDOK)
            /* don't close */
            return (TRUE);
      }
      break;

   case WM_DESTROY:
      /* resets BTRV and frees resources */
      BTRCALL (28, NULL, NULL, NULL, NULL, 255, 1);
      PostQuitMessage(0);
      break;
   } /* message */
   return DefWindowProc (hWnd, message, wParam, lParam);
} /* LogWndProc */

/*----------------------------------------------------------*
 * Procedure: InitInstance                                  *
 *----------------------------------------------------------*/

static BOOL InitInstance (HANDLE hInstance)
/*---------------------------------------*/
{
   WNDCLASS     wc;
   /* Register Application Frame Windows */
   wc.style         = 0;              /* Class style(s).                */
   wc.lpfnWndProc   = LogWndProc;
   wc.cbClsExtra    = 0;              /* No per-class extra data.       */
   wc.cbWndExtra    = 0;              /* No per-window extra data.      */
   wc.hInstance     = hInstance;      /* Application that owns the class*/
   wc.hIcon         = NULL; //LoadIcon (hInstance, "BLOGIN");
   wc.hCursor       = LoadCursor (NULL, IDC_ARROW);
   wc.hbrBackground = CreateSolidBrush (GetSysColor (COLOR_WINDOW));
   wc.lpszMenuName  = "LogMenu";
   wc.lpszClassName = "LoginClass";   /* Don't change the class name!!! */
   return RegisterClass (&wc);
} /* InitInstance */

/*----------------------------------------------------------*
 * Procedure: WinMain                                       *
 *----------------------------------------------------------*/

int PASCAL WinMain (HANDLE hNew, HANDLE hPrev, LPSTR lpCmdLine, int nCmdShow)
/*-------------------------------------------------------------------------*/
{
	HWND         hwndFrame;
	MSG          wm;
	hInst = hNew;
	if (hPrev || !InitInstance (hInst))
		return (0);
	hwndFrame = CreateWindow ("LoginClass", "Btrieve Server",
							  WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
							  CW_USEDEFAULT, CW_USEDEFAULT, 280, 180,
							  NULL, NULL, hNew, NULL);
	if (!hwndFrame) return (FALSE);
	CloseWindow (hwndFrame);
		
	while (GetMessage (&wm, NULL, NULL, NULL)) {
		TranslateMessage (&wm);
		DispatchMessage (&wm);
	}
}
