'THIS IS A BTRIEVE INTERFACE FOR POWER BASIC 3.00(c)   2/28/94
'INCLUDE THIS FILE IN YOUR PROGRAM
'
'
'This is dedicated to all PB PROGRAMMERS. If you could drop me a
'post card I would appreciate it!
' FBS SERVICES
' Bob Carleone
' Box 17710
' Phila., Pa. 19135
' 215-946-6798(voice)
' [74124,2623] Compuserve
'
'This interface will allow you to call BTRIEVE as a function the
'way you would in C or Pascal.
'The other interfaces always required you to get the segment and offset
'of your data buffer before the call.
'
'This led to endless lines like:
' vp%=CVI(MKL$(VARPTR(MYTYPE)))
' vs%=CVI(MKL$(VARSEG(MYTYPE)))
' vp%=VARPTR(MYTYPE) sometimes resulted in overflow errors and
' vp??=VARPTR(MYTPE) wouldn't pass to the interfaces without modification.

' All the documentation tells you to initialize the POSBLOCK like this:
' POSBLOCK$=SPACE$(128)
' DON'T DO IT!!! It took many hours to find this bug! Although NOVELL assures
' me it has been corrected in the updates to BTRIEVE. Pad it like this:
' POSBLOCK$=STRING$(128,0)
'---------------------------------------------------------------------------
'A SPECIAL thanks to DSE.SOFTWARE for advice in writing external
'routines for PB.
'---------------------------------------------------------------------------
'
'The call to BTRIEVE would look something like this:
'BtStatus% = BTRV%(OP%,FCB$,MyVAR,l%,KeyBuf$,KeyNo%)
'
'
DECLARE FUNCTION BTRV%(OPCODE%,POSBLOCK$,USERTYPE AS ANY,DBLENGTH%,KEYBUF$,KEYNO%)
$LINK "BT.OBJ"
       'OPCODE%    : OPEN,CLOSE,CREATE etc.
       '           : NOTE: If you pass a constant like 1 it
       '           : should be passed as 1%
       '
       'POSBLOCK$  : UNIQUE 128 byte block for Btrieve currency info
       '           : for each open file. Before the open initialize
       '           : to binary 0's. NEVER modify this block.
       '
       'USERTYPE   : The actual data buffer for Btrieve to return
       '           : record info. This must be a PB TYPED variable.
       '           : (SEE NOTE BELOW ON STRINGS)
       '           :
       'DBLENGTH%  : This is the length of the data buffer:
       '           : l%=LEN(MyTypeVar): Pass l% Not the LEN()
       '           : function because Btrieve will store the
       '           : length back into a temporary memory
       '           : location - you need it in l%
       '
       'KEYBUF$    : The KeyBuffer - on OPEN it will contain
       '           : the filename + a binary 0 or a space.
       '           : Make sure of this! On a data only file
       '           : it will open without the padded filename
       '           : but a step operation will return an end
       '           : of file!
       '           : Usually it will contain the key that you are
       '           : looking for.
       '           : DON'T modify this area between get next or
       '           : get previous operations.
       '
       'KEYNO%     : The Number of the key you are trying to establish
       '           : currency with or using for a insert,update,etc.
       '           : If it's a constant append the type declaration
       '           : character ie. 4%
       'STRINGS    :
       '           : If you need to use a STRING or a FLEX Data TYPE
       '           : pass the interface the opcode + 1000
       '           : like this:
       '           : opcode%=1000+1. Pass Opcode% or 1001%.
       '           :
       '           : The interface will determine the string's
       '           : length and memory location and pass it to Btrieve.
       '           : l% will still return the proper length that Btrieve
       '           : passes back after the call.
       '           : IMPORTANT : if you are using this form of the call
       '           : make SURE you pass the opcode% +1000. If not BTRIEVE
       '           : will modify the memory location where the string's
       '           : handle exists plus every sequential location
       '           : up to the value of l%.  This will most certainly be
       '           : disasterous!
       '           : FIXED LENGTH STRINGS (MyString * 100)
       '           : While I don't recommend their use here - fixed length
       '           : strings act like TYPED variables use the conventional
       '           : opcodes to make the call.

'SOME SIMPLE CALLS:
'TYPE MyTYPE
'  CUSTNAME AS STRING * 20
'  CUSTPHONE AS STRING * 12
'END TYPE

'DIM MyVAR AS SHARED MyTYPE
'DIM MYFCB AS SHARED STRING 
'OPEN:
'  %BTOPEN =1000    ;0+1000 using a string data buffer to open the file.
'  %GETEQUAL =5
'  FOPEN$=STRING$(92,0)
'  MYFCB=STRING$(128,0)
'  lopen%=0
'  l%=LEN(MyVAR)
'  keybuf$="MYFILE.DAT "
'  keyno% =0
'  status%=BTRV%(%BTOPEN,MYFCB,FOPEN$,lopen%,keybuf$,keyno%)  OR
'  status%=BTRV%(1000%,MYFCB,FOPEN$,lopen%,"MYFILE.DAT ",0%)
'  For OPEN the only important parameters are OPCODE%,POSBLOCK$, and KeyBuf$
'  However, watch the length that comes back make SURE you re-establish
'  the length of the databuffer after the open. This is why I use a throw-
'  away variable lopen%.
'
'  GET EQUAL
'  keyno%=1  ;Keys are zero relative this is key number 2
'  keybuf$="MARY JONES" 
'  status%=BTRV%(%GETEQUAL,MYFCB,MyVar,l%,keybuf$,keyno%)
'  IF ISFALSE status% THEN
'       ?"MARY JONES ";MyVar.CUSTPHONE
'  ELSE
'       Status_Code_Handler
'  END IF
