#ifndef __BTRTYPE_H
#define __BTRTYPE_H

enum dataType {
	btString = 0,							// Btrieve string class
	btInteger,								// integer class
	btFloat,								// floating point data type
	btDate,									// date type
	btTime,									// time type
	btDecimal,								// decimal type
	btMoney,								// money type
	btLogical,								// logical type
	btNumeric,								// numeric type,
	btBfloat,								// flaoting point
	btLstring,								// pascal string
	btZstring,								// C string
	btNote,									// note variable length
	btLvar,									// variable length binary
	btUnsigned,								// unsigned binary key
	btAutoinc,								// auto increment field
	btBit,									// bit type
	btNumericsts };							// numeric type

enum passwordMode {
	accessLock = 0,							// needs password to open the file only
	writeLock,								// needs password to write to the file
	accessEncrypt,							// needs password to open & decrypt the file
	writeEncrypt };							// needs password to write the encrypted file

enum lockType {
	btNoLock = 0,							// no record locking
	btGetKey = 50,							// add to get to test for a record without returning record
	btLockWait = 100,						// single record lock wait
	btLockNoWait = 200,						// single record no wait lock, no wait table lock
	btLockMultipleWait = 300,				// multiple record lock wait
	btLockMultipleNoWait = 400 };			// multiple record no wait lock, no wait table lock

//*******************************************************************
//	These are the error codes returned
const int btInvalidOperation = 1;
const int btIOError = 2;
const int btFileNotOpen = 3;
const int btKeyValueNotFound = 4;
const int btDuplicateKeyValue = 5;
const int btInvalidKeyNumber = 6;
const int btDifferentKeyNumber = 7;
const int btInvalidPositioning = 8;
const int btEndOfFile = 9;
const int btModifiableKeyValueError = 10;
const int btInvalidFileName = 11;
const int btFileNotFound = 12;
const int btExtendedFileError = 13;
const int btPreImageOpenError = 14;
const int btPreImageIOError = 15;
const int btExpansionError = 16;
const int btCloseError = 17;
const int btDiskFull = 18;
const int btUnrecoverableError = 19;
const int btRecordManagerActive = 20;
const int btKeyBufferTooShort = 21;
const int btDataBufferLength = 22;
const int btPositionBlockLength = 23;
const int btPageSizeError = 24;
const int btCreateIOError = 25;
const int btNumberOfKeys = 26;
const int btInvalidKeyPosition = 27;
const int btInvalidRecordLength = 28;
const int btInvalidKeyLength = 29;
const int btNotBtrieveFile = 30;
const int btFileAlreadyExtended = 31;
const int btExtendedIOError = 32;
const int btInvalidExtensionName = 34;
const int btDirectoryError = 35;
const int btTransactionError = 36;
const int btTransactionIsActive = 37;
const int btTransactionControlFileIOError = 38;
const int btEndAbortTransactionError = 39;
const int btTransactionMaxFiles = 40;
const int btOperationNotAllowed = 41;
const int btIncompleteAcceleratedAccess = 42;
const int btInvalidRecordAddress = 43;
const int btNullKeyPath = 44;
const int btInconsistentKeyFlags = 45;
const int btAccessToFileDenied = 46;
const int btMaximumOpenFiles = 47;
const int btInvAlternameSequenceDef = 48;
const int btKeyTypeError = 49;
const int btOwnerAlreadySet = 50;
const int btInvalidOwner = 51;
const int btErrorWritingCache = 52;
const int btInvalidInterface = 53;
const int btVariablePageError = 54;
const int btAutoIncrementError = 55;
const int btIncompleteIndex = 56;
const int btExpandedMemoryError = 57;
const int btCompressionBufTooShort = 58;
const int btFileAlreadyExists = 59;
const int btRejectCountReached = 60;
const int btWorkSpaceTooSmall = 61;
const int btIncorrectDescriptor = 62;
const int btInvalidExtendedInsertBuf = 63;
const int btFilterLimitReached = 64;
const int btIncorrectFieldOffset = 65;
const int btAutomaticTransactionAbort = 74;
const int btDeadlockDetected = 78;
const int btConflict = 80;
const int btLockError = 81;
const int btLostPosition = 82;
const int btReadOutsideTransaction = 83;
const int btRecordLocked = 84;
const int btFileLocked = 85;
const int btFileTableFull = 86;
const int btHandleTableFull = 87;
const int btIncompatibleMode = 88;
const int btRedirectedDeviceTableFull = 90;
const int btServerError = 91;
const int btTransactionTableFull = 92;
const int btIncompatibleLockType = 93;
const int btPermissionError = 94;
const int btSessionNoLongerValid = 95;
const int btCommunicationError = 96;
const int btDataMessageTooSmall = 97;
const int btInternalTransactionError = 98;
const int btLockParamOutOfRange = 1001;
const int btMemoryAllocation = 1002;
const int btMemoryTooSmall = 1003;
const int btPageSizeOutOfRange = 1004;
const int btInvalidPreimageDrive = 1005;
const int btPreimageBufferParam = 1006;
const int btFilesParamError = 1007;
const int btInvalidInitParam = 1008;
const int btInvalidTransactionParam = 1009;
const int btCompressionBufError = 1011;
const int btInvalidOpenFileParam = 1012;
const int btTaskListFull = 1013;
const int btStopWarning = 1014;
const int btAlreadyInitialized = 1016;
const int btInsufficientMemory = 2001;
const int btParameterInvalid = 2002;
const int btCannotAccessFiles = 2003;
const int btSpxNotInstalled = 2005;
const int btNoTaskSlots = 2007;
const int btFieldNameNotFound = 4001;
const int btKeyNameNotFound = 4002;
const int btInvalidParameter = 4003;
const int btIdentifierNotFound = 4004;
const int btInvalidConstant = 4005;
const int btSyntaxError = 4006;

//*******************************************************************
// create flags.  Return a combination of these on the Table::getFlags()
// call.
const int Xc_Truncate = 0x0002;				// truncate trailing blanks
const int Xc_Compress = 0x0008;				// compress the file
const int Xc_KeyOnly = 0x0010;				// key only file
const int Xc_Free10 = 0x0040;				// 10% free space threshold
const int Xc_Free20 = 0x0080;				// 20% free space threshold
const int Xc_Free30 = 0x00C0;				// 30% free space threshold

//*******************************************************************
// Use a combination of these bits on key segments to create a key
const short Xi_Duplicates = 0x0001;			// duplicates allowed
const short Xi_Modifiable = 0x0002;			// index may be modified
const short Xi_Binary = 0x0004;				// binary key
const short Xi_Null = 0x0008;				// key has a null value
const short Xi_Segment = 0x0010;			// another segment is concatenated
const short Xi_AltCollateSeq = 0x0020;		// index uses the alternate collating sequence
const short Xi_Descending = 0x0040;			// index is in descending order
const short Xi_Supplemental = 0x0080;		// index is a suplemental index
const short Xi_Extended = 0x0100;			// index is a extended data type
const short Xi_Manual = 0x200;				// index is a manual key

#endif
