#include "database.h"
#include "wbtrv.h"

/*-------------------------------------------------------------------------*/

#define WM_CALCULATE	(WM_USER + 0x123)

typedef struct {
	signed short   op;
	unsigned char  POS_BLK[128];
	unsigned char  key[256];
	signed short   keyNo;
	unsigned short len;
	unsigned char  data[2048];
}							 BTRVParms;

/*-------------------------------------------------------------------------*/

BOOL CopyToClipboard (HWND hWnd, HGLOBAL hData)
{
	UINT MY_FMT;
	if (OpenClipboard (hWnd)) {
		EmptyClipboard();
		MY_FMT = RegisterClipboardFormat ("BtrvServer");
		SetClipboardData (MY_FMT, hData);
		CloseClipboard();
	}
	return TRUE;
} /* CopyToClipboard */

/*-------------------------------------------------------------------------*/

int far pascal BTRCALL (int op, LPSTR posblk, LPSTR databuf,
		  unsigned far *len, LPSTR key, unsigned char keyLength, char keyNumber)
{
   HWND hLogin;
   int ret;

   if ((hLogin = FindWindow ("LoginClass", NULL)) == NULL) {
	  if (WinExec ("blogin.exe", SW_NORMAL) > 32)
		 hLogin = FindWindow ("LoginClass", NULL);
   }
   if (hLogin) {
	  HGLOBAL hParms = GlobalAlloc (GMEM_MOVEABLE | GMEM_SHARE, sizeof(BTRVParms));
	  BTRVParms far *BP = (BTRVParms far *)GlobalLock (hParms);
	  if (BP == NULL) return -9998;

	  BP->op = op;
	  BP->keyNo = keyNumber;
	  if (posblk) _fmemcpy (BP->POS_BLK, posblk, 128);

	  if (key) _fmemcpy (BP->key, key, keyLength);
	  else BP->key[0] = 0;

	  if (databuf and len and *len > 0) {
		 ASSERT(*len <= sizeof(BP->data));
		 BP->len = *len;
		 _fmemcpy (BP->data, databuf, *len);
	  } else {
		 BP->len = 0;
		 BP->data[0] = 0;
	  }

	  GlobalUnlock (hParms);
	  CopyToClipboard (theApp.m_pMainWnd->GetSafeHwnd(), hParms);
	  ret = (int)SendMessage (hLogin, WM_CALCULATE, 0, 0);

	  if (ret == 0) {
		 if (OpenClipboard (theApp.m_pMainWnd->GetSafeHwnd())) {
			 UINT MY_FMT = RegisterClipboardFormat ("BtrvServer");
			 HANDLE hData = GetClipboardData (MY_FMT);
			 BP = (BTRVParms far *)GlobalLock (hData);
			 if (BP != NULL) {
				 if (posblk) _fmemcpy (posblk, BP->POS_BLK, 128);
				 if (databuf and len and *len > 0)
					_fmemcpy (databuf, BP->data, *len = BP->len);
				 if (key)
					_fmemcpy (key, BP->key, keyLength);
				 GlobalUnlock (hData);
			 } else ret = -9996;
			 CloseClipboard();
		 } else ret = -9997;
	  }
   } else ret = -9999;
   return (ret);
} /* BTRV */

/*= An Example ============================================================*/

int Open (const char *pname, int mode)
{
   unsigned len = 0;
   status = BTRCALL (DOPEN, POS_BLK, "", &len, (LPSTR)pname,
					 (unsigned char)strlen(pname)+1, (char)mode);
   fileopen = status == 0;
   return status;
}

