#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <btrieve.h>

#include "p:\os286\aiacode\regs.h" /* change this line to the proper path */

#define make_far_pointer(s,o) (long) ( ( ( (long) ( (short) s) ) << 16 ) + o )

typedef struct msb {
   int ax,bx,cx,dx;
   int flags;
   int si,di,ds,es;
   }MSB;

typedef struct BTRIEVE_PARMS {
   char  *BUF_OFFSET;
   int   BUF_LEN;
   char  *CUR_OFFSET;
   char  *FCB_OFFSET;
   int   FUNCTION;
   char  *KEY_OFFSET;
   char  KEY_LENGTH;
   char  KEY_NUMBER;
   int   *STAT_OFFSET;
   int   XFACE_ID;
} BtrvParms;

int free_real_seg(void *);
int eclint(int,MSB *);
int CalcKeyLen(char *,int);
int btrvu(int,char *, void *, int *, void *,int, int);
int BTRV (int,char *, void *, int *, void *,int);
int init_btrv(unsigned int);
int exit_btrv(void);

void *eclalcrem(unsigned int);
void *eclrealseg(void);

int tempseg;

BtrvParms *btvdatptr;
char *btvdatseg;
int *p_status;
int *r_status;
char *p_pos_blk;
char *pos_blk;
char *p_key_buf;
char *key_buf;
char *p_data_buf;
char *data_buf;

int init_btrv(unsigned int MaxRecordSize)
{
   p_status=(int *)eclalcrem(sizeof(int));
   r_status=eclrealseg();

   btvdatptr=(BtrvParms *)eclalcrem(sizeof(BtrvParms));
   btvdatseg=eclrealseg();

   p_pos_blk = eclalcrem(128);
   pos_blk = eclrealseg();

   p_data_buf = eclalcrem(MaxRecordSize);
   data_buf = eclrealseg();

   p_key_buf = eclalcrem(255);
   key_buf = eclrealseg();

   return 1;
}

int exit_btrv()
{
   free_real_seg(p_status);
   free_real_seg(p_pos_blk);
   free_real_seg(p_data_buf);
   free_real_seg(p_key_buf);
   free_real_seg(btvdatptr);

   return 1;
}

int BTRV(int OP_CODE,char *POS_BLK, void *DATA, int *BUF_LEN, void *KEY_BUF,int KEY_NUM)
{
   int stat = 0;
   int KeyLen = 0;
   int operation;

   if(OP_CODE - WAIT_LOCK > 0)
      operation = OP_CODE - WAIT_LOCK;

   else if(OP_CODE - NOWAIT_LOCK > 0)
      operation = OP_CODE - NOWAIT_LOCK;

   else if(OP_CODE - MULTIPLE_WAIT_LOCK > 0)
      operation = OP_CODE - MULTIPLE_WAIT_LOCK;

   else if(OP_CODE - MULTIPLE_NOWAIT_LOCK > 0)
      operation = OP_CODE - MULTIPLE_NOWAIT_LOCK;

   else if(OP_CODE - GET_KEY > 0)
      operation = OP_CODE - GET_KEY;

   else
      operation = OP_CODE;

   switch(operation) {
      case B_OPEN:
      case B_CREATE:
      case B_SET_OWNER:
      case B_RESET:
         if(KEY_BUF)
            KeyLen = strlen(KEY_BUF)+1;
         else
            KeyLen = 0;
         break;

      case B_ABORT:
      case B_END:
      case B_CLOSE:
      case B_BEGIN:
      case B_CLR_OWNER:
      case B_CREATE_INDEX:
      case B_DELETE:
      case B_DROP_INDEX:
      case B_EXTEND:
      case B_GETPOS:
      case B_STEP_FIRST:
      case B_STEP_LAST:
      case B_STEP_NEXT:
      case B_STEP_NEXT_EXT:
      case B_STEP_PREVIOUS:
      case B_STEP_PREV_EXT:
      case B_STOP:
      case B_UNLOCK:
      case B_VERSION:
         break;

      case B_STAT:
         KeyLen = 64;
         break;

      case B_GETDIR:
         KeyLen = 65;
         break;

      default:
         KeyLen = CalcKeyLen(POS_BLK,KEY_NUM);
      }

   stat = btrvu(OP_CODE,POS_BLK,DATA,BUF_LEN,KEY_BUF,KEY_NUM,KeyLen);

   return stat;
}

int btrvu(int OP_CODE,char *POS_BLK, void *DATA, int *BUF_LEN, void *KEY_BUF,int KEY_NUM, int KEY_LEN)
{
   int stat;
   struct msb eclregs;
   static int btrvup=0;
   int retval = 0;

   if (!btrvup) {
      memset(&eclregs,0,sizeof(eclregs));

      eclregs.ax=0x357B;
      eclint(0x21,&eclregs);

      if(eclregs.bx != 0x33)
         return 20;
      else
         btrvup=1;
      }

   *p_status=0;

   if(POS_BLK)
      memcpy(p_pos_blk,POS_BLK,128);
   else
      memset(p_pos_blk,0,128);

   if(DATA)
      memcpy(p_data_buf,DATA,*BUF_LEN);
   else if(BUF_LEN)
      memset(p_data_buf,0,*BUF_LEN);

   if(KEY_BUF)
      memcpy(p_key_buf,KEY_BUF,KEY_LEN);
   else
      *p_key_buf = 0;

   btvdatptr->BUF_OFFSET  = data_buf;
   if(BUF_LEN)
      btvdatptr->BUF_LEN    = *BUF_LEN;
   else
      btvdatptr->BUF_LEN    = 0;
   btvdatptr->CUR_OFFSET  = pos_blk+38;
   btvdatptr->FCB_OFFSET  = pos_blk;
   btvdatptr->FUNCTION    = OP_CODE;
   btvdatptr->KEY_OFFSET  = key_buf;
   btvdatptr->KEY_LENGTH  = (char)255;
   btvdatptr->KEY_NUMBER  = (char)KEY_NUM;
   btvdatptr->STAT_OFFSET = r_status;
   btvdatptr->XFACE_ID    = 24950;

   memset(&eclregs,0,sizeof(eclregs));

   eclregs.dx=0;
   eclregs.ds=FP_SEG(btvdatseg);

   eclint(0x7B,&eclregs);

   stat = *p_status;

   if(POS_BLK)
      memcpy(POS_BLK,p_pos_blk,128);

   if(DATA && BUF_LEN)
      memcpy(DATA,p_data_buf,*BUF_LEN);

   if(KEY_BUF)
      memcpy(KEY_BUF,p_key_buf,KEY_LEN);

   if(BUF_LEN)
      *BUF_LEN = btvdatptr->BUF_LEN;

   return(stat);
}

int eclint (int intno, MSB *m)
{
   regAL = (unsigned char) intno;
   regAH = (unsigned char) intno;
   regDS = FP_SEG(m);
   regDX = FP_OFF(m);
   regBX = 18;

   regES = 0;

   dos(0xE3);

   return regFlags;
}

void *eclalcrem(unsigned int buf_size)
{
   char *p_ptr;
   regAL = 2;
   regCX = 0;
   regDX = buf_size;

   if(dos(0xE8))
      return 0L;

   tempseg = regBX;

   p_ptr = (char *)make_far_pointer(regAX, 0);

   return p_ptr;
}

void *eclrealseg()
{
   char *r_ptr;

   r_ptr = (char *)make_far_pointer(tempseg, 0);

   return r_ptr;
}

int free_real_seg(void *ptr)
{
   regAL = 0;
   regES = FP_SEG(ptr);
   dos(0x49);
   return(regAX);
}

int CalcKeyLen(char *POS_BLK,int KEY_NUM)
{
   int i,keyno,klen,KeyLength = 0;
   char STAT_BLK[128];
   char KeyBuf[64];
   BTRIEVE_FILE_BUFFER btrv_buf;

   int buflen = sizeof(btrv_buf);

   memcpy(STAT_BLK,POS_BLK,128);

   btrvu(B_STAT,STAT_BLK,&btrv_buf,&buflen,KeyBuf,0,0);

   for (i=0,keyno=0; keyno < btrv_buf.NDX_CNT; i++,keyno++) {

      klen=btrv_buf.KEY_BUF[i].KEY_LEN;

      while(btrv_buf.KEY_BUF[i].KEY_FLAG & B_SEGMENTED)
         klen+=btrv_buf.KEY_BUF[++i].KEY_LEN;

      if(keyno == KEY_NUM)
         KeyLength+=klen;
      }

   return KeyLength;
}

