#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <btrieve.h>

#include "p:\run286\inc\phapi.h"

typedef struct BTRIEVE_PARMS {
   char  *BUF_OFFSET;
   int   BUF_LEN;
   char  *CUR_OFFSET;
   char  *FCB_OFFSET;
   int   FUNCTION;
   char  *KEY_OFFSET;
   char  KEY_LENGTH;
   char  KEY_NUMBER;
   int   *STAT_OFFSET;
   int   XFACE_ID;
} BtrvParms;

int CalcKeyLen(char *,int);
int btrvu(int,char *, void *, int *, void *,int, int);
int BTRV (int,char *, void *, int *, void *,int);
int init_btrv(unsigned int);
int exit_btrv(void);

void *eclalcrem(unsigned int);
void *eclrealseg(void);

BtrvParms *btvdatptr;

BtrvParms *btvdatseg;

int  *p_status;
char *p_pos_blk;
char *p_key_buf;
char *p_data_buf;

int  *r_status;
char *pos_blk;
char *key_buf;
char *data_buf;

int init_btrv(unsigned int MaxRecordSize)
{
   USHORT tempseg;
   SEL    tempsel;

   DosAllocRealSeg(sizeof(int),&tempseg,&tempsel);
   r_status = MAKEP(tempseg,0);
   p_status = MAKEP(tempsel,0);

   DosAllocRealSeg(sizeof(BtrvParms),&tempseg,&tempsel);
   btvdatseg = MAKEP(tempseg,0);
   btvdatptr = MAKEP(tempsel,0);

   DosAllocRealSeg(128L,&tempseg,&tempsel);
   pos_blk   = MAKEP(tempseg,0);
   p_pos_blk = MAKEP(tempsel,0);

   DosAllocRealSeg((unsigned long)MaxRecordSize,&tempseg,&tempsel); 
   data_buf   = MAKEP(tempseg,0);
   p_data_buf = MAKEP(tempsel,0);

   DosAllocRealSeg(256L,&tempseg,&tempsel);
   key_buf   = MAKEP(tempseg,0);
   p_key_buf = MAKEP(tempsel,0);

   return 1;
}

int exit_btrv()
{
   DosFreeSeg(SELECTOROF(p_status));
   DosFreeSeg(SELECTOROF(p_pos_blk));
   DosFreeSeg(SELECTOROF(p_data_buf));
   DosFreeSeg(SELECTOROF(p_key_buf));
   DosFreeSeg(SELECTOROF(btvdatptr));

   return 1;
}

int BTRV(int OP_CODE,char *POS_BLK, void *DATA, int *BUF_LEN, void *KEY_BUF,int KEY_NUM)
{
   int stat = 0;
   int KeyLen = 0;
   int operation;
   int retry = 0;

   if(OP_CODE - MULTIPLE_NOWAIT_LOCK > 0)
      operation = OP_CODE - MULTIPLE_NOWAIT_LOCK;

   else if(OP_CODE - MULTIPLE_WAIT_LOCK > 0)
      operation = OP_CODE - MULTIPLE_WAIT_LOCK;

   else if(OP_CODE - NOWAIT_LOCK > 0)
      operation = OP_CODE - NOWAIT_LOCK;

   else if(OP_CODE - WAIT_LOCK > 0)
      operation = OP_CODE - WAIT_LOCK;

   else if(OP_CODE - GET_KEY > 0)
      operation = OP_CODE - GET_KEY;

   else
      operation = OP_CODE;

   switch(operation) {
      case B_OPEN:
      case B_CREATE:
      case B_SET_OWNER:
      case B_RESET:
         if(KEY_BUF)
            KeyLen = strlen(KEY_BUF)+1;
         else
            KeyLen = 0;
         break;

      case B_ABORT:
      case B_END:
      case B_CLOSE:
      case B_BEGIN:
      case B_CLR_OWNER:
      case B_CREATE_INDEX:
      case B_DELETE:
      case B_DROP_INDEX:
      case B_EXTEND:
      case B_GETPOS:
      case B_STEP_FIRST:
      case B_STEP_LAST:
      case B_STEP_NEXT:
      case B_STEP_NEXT_EXT:
      case B_STEP_PREVIOUS:
      case B_STEP_PREV_EXT:
      case B_STOP:
      case B_UNLOCK:
      case B_VERSION:
         break;

      case B_STAT:
         KeyLen = 64;
         break;

      case B_GETDIR:
         KeyLen = 65;
         break;

      default:
         KeyLen = CalcKeyLen(POS_BLK,KEY_NUM);
         if(KeyLen < 0)
            return (KeyLen * -1);
      }

   RETRY:

   stat = btrvu(OP_CODE,POS_BLK,DATA,BUF_LEN,KEY_BUF,KEY_NUM,KeyLen);

   if(OP_CODE == B_OPEN && stat == 85 && retry < 50) {  /* file in use */
      retry++;
      goto RETRY;
      }

   return stat;
}

int btrvu(int OP_CODE,char *POS_BLK, void *DATA, int *BUF_LEN, void *KEY_BUF,int KEY_NUM, int KEY_LEN)
{
   int stat;
   REGS16 r;
   static int btrvup=0;
   int retval = 0;

   if (!btrvup) {
      memset(&r,0,sizeof(REGS16));

      r.ax=0x357B;
      DosRealIntr(0x21,&r,0L,0);

      if(r.bx != 0x33)
         return 20;
      else
         btrvup=1;
      }

   *p_status=0;

   if(POS_BLK)
      memcpy(p_pos_blk,POS_BLK,128);
   else
      memset(p_pos_blk,0,128);

   if(DATA)
      memcpy(p_data_buf,DATA,*BUF_LEN);
   else if(BUF_LEN)
      memset(p_data_buf,0,*BUF_LEN);

   if(KEY_BUF)
      memcpy(p_key_buf,KEY_BUF,KEY_LEN);
   else
      *p_key_buf = 0;

   btvdatptr->BUF_OFFSET  = data_buf;
   if(BUF_LEN)
      btvdatptr->BUF_LEN    = *BUF_LEN;
   else
      btvdatptr->BUF_LEN    = 0;
   btvdatptr->CUR_OFFSET  = pos_blk+38;
   btvdatptr->FCB_OFFSET  = pos_blk;
   btvdatptr->FUNCTION    = OP_CODE;
   btvdatptr->KEY_OFFSET  = key_buf;
   btvdatptr->KEY_LENGTH  = (char)255;
   btvdatptr->KEY_NUMBER  = (char)KEY_NUM;
   btvdatptr->STAT_OFFSET = r_status;
   btvdatptr->XFACE_ID    = 24950;

   memset(&r,0,sizeof(REGS16));

   r.dx=0;
   r.ds=SELECTOROF(btvdatseg);

   DosRealIntr(0x7B,&r,0L,0);

   stat = *p_status;

   if(POS_BLK)
      memcpy(POS_BLK,p_pos_blk,128);

   if(DATA && BUF_LEN)
      memcpy(DATA,p_data_buf,*BUF_LEN);

   if(KEY_BUF)
      memcpy(KEY_BUF,p_key_buf,KEY_LEN);

   if(BUF_LEN)
      *BUF_LEN = btvdatptr->BUF_LEN;

   return(stat);
}

int CalcKeyLen(char *POS_BLK,int KEY_NUM)
{
   int status;
   int i,keyno,klen,KeyLength = 0;
   char STAT_BLK[128];
   char KeyBuf[64];
   BTRIEVE_FILE_BUFFER btrv_buf;

   int buflen = sizeof(btrv_buf);

   memcpy(STAT_BLK,POS_BLK,128);

   status = btrvu(B_STAT,STAT_BLK,&btrv_buf,&buflen,KeyBuf,0,0);

   if(!status) {

      for (i=0,keyno=0; keyno < btrv_buf.NDX_CNT; i++,keyno++) {

         klen=btrv_buf.KEY_BUF[i].KEY_LEN;

         while(btrv_buf.KEY_BUF[i].KEY_FLAG & B_SEGMENTED)
            klen+=btrv_buf.KEY_BUF[++i].KEY_LEN;

         if(keyno == KEY_NUM)
            KeyLength+=klen;
         }
      }
   else
      return (status * -1);

   return KeyLength;
}

